# TTCAN benchmark

This benchmark executes on a Raspberry Pi Pico (RP2040). It runs the TTCAN driver on randomised inputs and measures the runtime, sending the results to the UART console.

## Building
Build with cmake. The Pico SDK should be automatically downloaded from git and built.

```
mkdir build
cd build
cmake .. -DPICO_SDK_FETCH_FROM_GIT=1
make -j8
```

## Flashing
I flashed with OpenOCD. Mainline OpenOCD does not support RP2040 yet. I followed [the instructions here](https://www.raspberrypi.com/documentation/microcontrollers/debug-probe.html).

```
openocd -f interface/cmsis-dap.cfg -f target/rp2040.cfg -c "adapter speed 5000" -c "program app_can_time.elf verify reset exit"
```

## Extracting results
I used screen to connect to the microcontroller and read the results:
```
screen /dev/cu.usbmodem1402 115200
```
Then I enabled logging (`CTRL-A :log`) to save the results to a CSV.
